/*
 * Drive_Functions.h
 *
 * Created: 2020
 */ 


#ifndef DRIVE_FUNCTIONS_H_
#define DRIVE_FUNCTIONS_H_

#define	PWMA				OCR0A //Overflow compare register A
#define PWMB				OCR0B //Overflow compare register B

void Forward (unsigned char, unsigned char); //Direction with velocity A and B,for driving straight and driving a curve
void Backward (unsigned char, unsigned char); //Direction with velocity A and B,for driving straight and driving a curve
void Turn_right (unsigned char); //Rotate on the spot right, same velocity of the wheels
void Turn_left (unsigned char); //Rotate on the spot left, same velocity of the wheels
void Stop (void); //Stop all Motors

//Motors forward
void Forward (unsigned char velocity_A, unsigned char velocity_B) {
	PWMA = velocity_A; //Pulswidth modulation
	PWMB = velocity_B; //
	PORTB &= ~(1 << PORTB0) & ~(1 << PORTB1); //PORTB 0bxxxxxx00
}

//Motors backward
void Backward (unsigned char velocity_A, unsigned char velocity_B) {
	PWMA = 255 - velocity_A; //Pulswidth modulation
	PWMB = 255 - velocity_B; //
	PORTB |= (1 << PORTB0) | (1 << PORTB1); //PORTB 0bxxxxxx11
}

//To be verified:
//Turn right on the spot
void Turn_right (unsigned char velocity) {
	PWMA = velocity; //Same velocity at all wheels
	PWMB = 255 - velocity; //
	PORTB |=  (1 << PORTB0); //But different directions
	PORTB &= ~(1 << PORTB1);
}

//Turn left on the spot
void Turn_left (unsigned char velocity) {
	PWMA = 255 - velocity; //Same velocity at all wheels
	PWMB = velocity; //
	PORTB &= ~(1 << PORTB0); //But different directions
	PORTB |=  (1 << PORTB1);
}

//Stop the motors
void Stop (void) {
	PWMA = 0; //All...
	PWMB = 0; //...parameters...
	PORTB &= ~(1 << PORTB0) & ~(1 << PORTB); //...down
}

#endif /* DRIVE_FUNCTIONS_H_ */